#!/usr/bin/python

'''All the code for the Crop pane in the main notebook goes here.'''

import pygtk
pygtk.require('2.0')
try:
    import gobject
    import gtk
except:
    print "You need to install pyGTK or GTKv2 ",
    print "or set your PYTHONPATH correctly."
    sys.exit(1)

import config
import Model
from oneline import comm
from GUI.GroupPane import GroupSubPane
from GUI.GroupPane import GroupNotebookPane
from GUI.misc import prompt_and_rbtns
from GUI.misc import set_lower
import strings as _

class CropSubPane(GroupSubPane):
    'Crop pane for one group of files.'
    def __init__(self, M, id):
        '''Create the crop options pane for a specific group of files.

        M is the data model.  It is an object with file, path and
        crop attributes.  We'll create crop groups and stick them
        in M. 

        id is the unique identifier of the group.  It's a mangled path
        of some kind.'''

        GroupSubPane.__init__(self, M, id)

        self.group_id = id

        ## Idiomatic switch statement
        mode = {
            Model.AUTO: 0,
            Model.IGNORE: 1,
            }[M.crop.group[self.group_id].mode]

        ## Content
        self.content.pack_start(
            prompt_and_rbtns(_.crop_needed_prompt,
                             [_.yes_not_sure, _.no],
                             self.crop_rbtn_cb, M, default=mode) , False)
        self.add_with_viewport(self.content)

    def set_lower(self, widget):
        '''Set the lower part of the pane to the widget.'''
        if not hasattr(self, 'lower'):
            self.lower = gtk.VBox()        
        set_lower(self, widget, self.lower, self.content)

    def crop_rbtn_cb(self, widget, num, M):
        if widget.get_active():
            if num == 0:
                M.crop.group[self.group_id].mode = Model.AUTO
            elif num == 1:
                M.crop.group[self.group_id].mode = Model.IGNORE
            comm.verbose("Set crop %s mode to %d" % (
                    self.group_id, M.crop.group[self.group_id].mode))
        

class CropPane(GroupNotebookPane):
    'Main pane display crop options'
    def __init__(self, M):
        'Pane for setting crop options.'
        GroupNotebookPane.__init__(self, M, CropSubPane)
        self.make_tab('_Crop', gtk.STOCK_CUT)

    def map_cb(self, action):
        'Called when this pane is chosen and becomes visible.'
        config.help_url='help:crop'
