#!/usr/bin/python
import gtk
import os
import gnomecanvas
import graphic

class RectSelectCanvas(gnomecanvas.Canvas):
    '''Display a graphic and let user select a rectangle on that image'''
    def __init__(self, image_spec, width=900, height=900):
	'''image_spec = image instance, graphic instance or filename of image to load
        width = max width of canvas
        height = max height of canvas'''

        ## Make graphic instance (load file if needed), then scale image
        self.im = graphic.graphic(image_spec)
        self.orig_w = self.im.w
        self.orig_h = self.im.h
        if self.im.w > width or self.im.h > height:
            self.im.thumbnail((height, width))

        ## Setup canvas
	gnomecanvas.Canvas.__init__(self, aa=True)
	self.set_size_request(self.im.w, self.im.h)
	self.set_scroll_region(0, 0, self.im.w, self.im.h)
	self.connect("button_press_event", self.btn_press_event)
	self.connect("button_release_event", self.btn_release_event)
	self.connect("motion_notify_event", self.motion_event)
        self.root().add(gnomecanvas.CanvasPixbuf, pixbuf=self.im.pixbuf())

    def motion_event(self, widget, event):
	try:
	    self.select.set(x2=event.x, y2=event.y)
        except:
            pass

    def btn_press_event(self, widget, event):
        if event.button == 1:
            self.x = event.x
            self.y = event.y
            self.select = self.root().add(gnomecanvas.CanvasRect, 
                                          x1=event.x, y1=event.y, x2=event.x, y2=event.y, 
                                          fill_color_rgba=0xFF000066)
            
    def btn_release_event(self, widget, event):
	if event.button == 1:
            try:
                self.select.destroy()
                self.select = 0  ## shouldn't be necessary, but python segfaults w/o it
                print self.x, self.y, event.x, event.y
                print self.scale(self.x, self.y), self.scale(event.x, event.y)
            except:
                pass

    def scale(self, x, y):
        "Return x,y scaled to reflect the original thumbnail transformation."
        return (self.orig_w / self.im.w * x, self.orig_h / self.im.h * y)
        

if __name__ == '__main__':
    window = gtk.Window()
    window.connect('destroy', gtk.main_quit)
    window.add(RectSelectCanvas("foo.png"))
    window.show_all()
    gtk.main()
