#!/usr/bin/python
'''This module contains pygtk widgets of generic use and application.'''

import pygtk
pygtk.require('2.0')
import gtk

class ErrorDlg(gtk.MessageDialog):
    '''Display error message,

    msg - The error message that gets displayed.
    '''
    def __init__(self, msg, parent=None):
	gtk.MessageDialog.__init__(self, parent, 0, 
                                   gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, msg)
	self.run()
	self.destroy()

class OkDlg(gtk.MessageDialog):
    '''Display ok dialog'''
    def __init__(self, msg, parent=None):
	gtk.MessageDialog.__init__(self, parent, 0, 
                                   gtk.MESSAGE_INFO, gtk.BUTTONS_OK, msg)
        #self.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
	self.result = self.run()
        self.destroy()
        
class  OkCancelDlg(gtk.MessageDialog):
    '''Display ok/cancel dialog

    self.result = OkCancelDlg(message_text).result

    self.result will be gtk.RESPONSE_CANCEL or gtk.RESPONSE_OK or
    gtk.RESPONSE_DELETE_EVENT (if esc is pressed) '''

    result = None
    def __init__(self, msg, parent=None):
	gtk.MessageDialog.__init__(self, parent, 0, 
                                   gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, msg)
        self.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
	self.result = self.run()
        self.destroy()


def rbtn_group(label, callback, *args):
    '''Returns a list of radio buttons, all in a group.  One for each
    element of label.  First button is active.  They're all set to
    call callback with the widget, the index of the selected button
    and then *args as arguments when toggled. And show() method is
    called on each one.'''

    rbtn = []
    count = 0
    for l in label:
        if len(rbtn) == 0:
            group = None
        else:
            group = rbtn[0]
        rbtn.append(gtk.RadioButton(group, l))
        rbtn[-1].connect("toggled", callback, count, *args)
        rbtn[-1].show()
        count = count + 1
    rbtn[0].set_active(True)
    return rbtn

def rbtn_vbox(*args, **kwargs):
    '''Makes an rbtn_group, packs it into a vbox and returns it.

    If kwargs['default'] specifies a button, set that button active'''
    rbtn_box = gtk.VBox()
    rbtns = rbtn_group(*args)
    for rbtn in rbtns:
        rbtn_box.pack_start(rbtn, True, True, 0)
    try:
        rbtns[kwargs['default']].set_active(True)
    except:
        pass
    return rbtn_box

def prompt_and_rbtns(prompt, *args, **kwargs):
    '''Return a vbox containing a prompt and some radio buttons beneath it.'''

    hbox = gtk.HBox()
    label = gtk.Label(prompt)
    label.set_line_wrap(True)
    hbox.pack_start(label, False)
    vbox = gtk.VBox()
    vbox.pack_start(hbox, False, padding = 10)
    vbox.pack_start(rbtn_vbox(*args, **kwargs), False)
    return vbox

def set_lower(self, widget, lower, content):
    '''Put the widget in the lower box and pack that in to the content box.

    Add a separator above the widget and show_all()

    Use this function to call set_lower:
    from GUI.misc import set_lower
    def set_lower(self, widget):
        if not hasattr(self, 'lower'):
            self.lower = gtk.VBox()        
        set_lower(self, widget, self.lower, self.content)
        '''

    if hasattr(self, 'lower'):
        self.lower.destroy()
    self.lower = gtk.VBox()
    self.lower.pack_start(gtk.HSeparator(), False, padding=5)
    self.lower.pack_start(widget)
    self.content.pack_start(self.lower, False, False)
    self.show_all()
