#!/usr/bin/python

'''Config options, constants and defaults'''

import os, sys

version = "0.1"
program_name = 'Bkrpr'
bin_name = program_name.lower()
data_fname = "%s.data" % bin_name

## Use these to set thresholds for bkrpr to use in deciding whether a
## pixel is white, black or grey
white_min = 256/4
black_max = 256/3

## Chattiness
QUIET=0
VERBOSE=1
DEBUG=2
verbose_level = DEBUG
def verbose(): return(verbose_level >= VERBOSE)
def debug(): return(verbose_level == DEBUG)

# Continue.  Set to True to enable skipping of files that have already been
# generated.  Skipping is automatically enabled with opening an
# existing dir.  In advanced mode, one can set it manually.
cont = False


cli = True # I wonder what this option does?

## Files are checked for these extensions so we know what we can read
## and write.  This is just a subset of the extensions that Python PIL
## can handle.
in_formats = ['BMP', 'CUR', 'DCX', 'FLI', 'FLC', 'FPX', 'GBR', 'GD', 'GIF', 
              'ICO', 'IM', 'IMT', 'JPEG', 'JPG', 'MIC', 'MSP', 'PCD', 'PCX', 
              'PDF', 'PIXAR', 'PNG', 'PPM', 'PSD', 'SGI', 'TIFF', 'TIF', 
              'WAL', 'XBM', 'XPM']
out_formats = ['BMP', 'EPS', 'GIF', 'IM', 'JPEG', 'JPG', 'MSP', 'PALM', 
               'PCX', 'PDF', 'PNG', 'PPM', 'TIFF', 'TIF', 'XBM']
## Input and output formats in lower case
in_formats_lc =  [ x.lower() for x in in_formats ]
out_formats_lc =  [ x.lower() for x in out_formats ]


## Shouldn't need to change this unless repackaging bkrpr
icon_dir = sys.path[0]+'/images'

## A character that won't normally appear in any filenames
fname_token = '*'



## user experience level
BEGINNER = 0
INTERMEDIATE = 1
ADVANCED = 2
default_user_level = BEGINNER
user_level = default_user_level ## TODO pull this value from .bkrpr 

def intermediate(): return user_level >= INTERMEDIATE
def advanced(): return user_level == ADVANCED

## Help url
homepage = "http://bkrpr.org/"
base_help_url = homepage + "doku.php?id="
help_url = "help"  ## this will change as the user clicks around so that help is context-sensitive
