'''OCR  using Ocropus and Tesseract
Copyright 2008 James Vasile
Released under GPLv3
See LICENSE, gplv3 or http://www.gnu.org/licenses/gpl-3.0.html

Based on pytesser.py, which was released under Apache 2.0 license:
OCR in Python using the Tesseract engine from Google
http://code.google.com/p/pytesser/
by Michael J.T. O'Kelly
V 0.0.1, 3/10/07

Some minor modifications made by James Vasile.
'''


import os

def image_to_scratch(im, scratch_image_name):
	"""Saves image in memory to scratch file.  .bmp format will be read
	correctly by Tesseract.  .png can be read by ocropus"""
	im.save(scratch_image_name, dpi=(200,200))

def retrieve_text(scratch_text_name_root, extension ='.txt'):
	inf = file(scratch_text_name_root + extension)
	text = inf.read()
	inf.close()
	return text

def cleanup(scratch_image_name, scratch_text_name_root='pyocrtemp'):
	"""Clean up temporary files from disk"""
	for name in (scratch_image_name, scratch_text_name_root + '.txt', "tesseract.log"):
		try:
			os.remove(name)
		except OSError:
			pass
