#!/usr/bin/python

'''
Archive a daily build of the trunk.
'''

import os, sys
import datetime
import util_mail
from dist import make_tgz

dest = "/home/james/bkrpr.org/download"
link = 'daily.tgz'

if not os.path.exists(dest):
    dest = os.getcwd()
link = dest + '/' + link

def try_daily(dest, n=3):
    try:
        today = datetime.date.today()
        tgz = dest + '/bkrpr-' + str(today) + '.tgz'
        final_filename = make_tgz(tgz)
        return tgz, final_filename
    except:
        if n == 1:
            raise
        else:
            return try_daily(dest, n-1)

def update_link(link, dest):
    '''Point link at dest, delete what it used to point at.'''
    try:
        curr_dest = os.readlink(link)
        os.remove(link)
        os.remove(curr_dest)
    except:
        pass
    os.symlink(dest, link)

def main():
    tgz, final_filename = try_daily(dest, 3)
    update_link(link, tgz)

if __name__ == '__main__':
    try:
        main()
    except:
        import traceback
        tb = traceback.format_exc()
        print tb
        sendMail('bkrpr@noreply.net','james@hackervisions.org','Bkrpr daily package failed',tb)
